(function($){
	freshlibObject = function() {
		this.selector = null;
		this.validate = function() {
			alert(this.selector);
		}

/*******************************************************************************
* COMMENT FORM VALIDATION
*******************************************************************************/		
		this.validateCommentForm = function( invalidInputCallback, validInputCallback ) {
			
			var $form = $(this.selector);
			if( $form.size() == 0 ) return;
			
			var $commentAuthor = $form.find('input[name="author"]');
			var $commentEmail = $form.find('input[name="email"]');
			var $commentContent = $form.find('textarea[name="comment"]');
			
			var $submitButton = $form.find('input[type="submit"]');
			
			
			
			$submitButton.click(function() {
				var emailFilter = /^([a-zA-Z0-9_.-])+@(([a-zA-Z0-9-])+.)+([a-zA-Z0-9]{2,4})+$/;
				var isValid = true;
				
				if( $commentAuthor.size() > 0 && $commentAuthor.val() == '' ) {
					isValid = false;
					invalidInputCallback( $commentAuthor );
				}
				
				if( $commentEmail.size() > 0 && ($commentEmail.val() == '' || !emailFilter.test( $commentEmail.val() ) ) ) {
					isValid = false;
					invalidInputCallback( $commentEmail );
				}			
				
				if( $commentContent.val() == '' ) {
					isValid = false;
					invalidInputCallback( $commentContent );
				}
				
				if( isValid == false ) {
					return false;
				}
				
				if( isValid == true && validInputCallback != undefined ) {
					validInputCallback( $form );
				}
			});
		}
		
/*******************************************************************************
* CONTACT FORM VALIDATION
*******************************************************************************/		
			this.validateContactForm = function( invalidInputCallback, validInputCallback ) {
				
				var $form = $(this.selector);
				if( $form.size() == 0 ) return;
				
				var $commentAuthor = $form.find('input[name*="author"]');
				var $commentEmail = $form.find('input[name*="email"]');
				var $commentContent = $form.find('textarea[name*="text"]');
				var $submitButton = $form.find('input[type="submit"]');
				
				$submitButton.click(function() {
					var emailFilter = /^([a-zA-Z0-9_.-])+@(([a-zA-Z0-9-])+.)+([a-zA-Z0-9]{2,4})+$/;
					var isValid = true;
					
					if( $commentAuthor.size() > 0 && $commentAuthor.val() == '' ) {
						isValid = false;
						invalidInputCallback( $commentAuthor );
					}
					
					if( $commentEmail.size() > 0 && ($commentEmail.val() == '' || !emailFilter.test( $commentEmail.val() ) ) ) {
						isValid = false;
						invalidInputCallback( $commentEmail );
					}			
					
					if( $commentContent.val() == '' ) {
						isValid = false;
						invalidInputCallback( $commentContent );
					}
					
					if( isValid == false ) {
						return false;
					}
					
					if( isValid == true && validInputCallback != undefined ) {
						validInputCallback( $form );
					}
				});
			}		
/*******************************************************************************
* LIGHTBOX BINDING
*******************************************************************************/		
			this.bindLightbox = function( attribute, value, callback ) {
				
				var imageExtensionsArray = new Array();
				imageExtensionsArray.push('jpg');
				imageExtensionsArray.push('jpeg');
				imageExtensionsArray.push('gif');
				imageExtensionsArray.push('png');
				imageExtensionsArray.push('bmp');
				imageExtensionsArray.push('ico');
				imageExtensionsArray.push('svg');
				var imageExtensions = imageExtensionsArray.join('|');
				
				
				
				var imageFilter = new RegExp(  '(?:([^:/?#]+):)?(?://([^/?#]*))?([^?#]*\\.(?:'+imageExtensions+'))(?:\\?([^#]*))?(?:#(.*))?'); 
					
					
				var $imgWithLink = $(this.selector);	
				$imgWithLink.each(function() {
					var $link = $(this).parent();
					
					if( imageFilter.test($link.attr('href')) ) {
						$link.attr(attribute,value);
					}
				}).promise().done(function() {
					callback();
				});
			}			
		
		this.selector = null;
	}
	

	
	
/*******************************************************************************
* FRESHLIB SINGLETON
*******************************************************************************/	
	freshlib = function( selector ) {	
		freshlib.instance = null
		if(freshlib.instance == null) {
			freshlib.instance = new freshlibObject();
		}
		
		freshlib.instance.selector = selector;
		return freshlib.instance;
	}
})(jQuery);